import { system, world } from '@minecraft/server'
import { Menu } from "./flash_ui.js"




world.afterEvents.itemUse.subscribe((data) => {
	const player = data.source
	if (data.itemStack.typeId === "flash:dose_tracker" && player.isSneaking) {
		player.runCommandAsync('function abilities/dose_tracker_sneaking')
	}
	if (data.itemStack.typeId === "flash:dose_tracker" && !player.isSneaking) {
		player.runCommandAsync('function abilities/dose_tracker')
	}
	if (data.itemStack.typeId === "flash:velocity_nine" && !player.isSneaking) {
		player.runCommandAsync('function abilities/velocity_nine')
	}
	if (data.itemStack.typeId === "flash:antidote" && !player.isSneaking) {
		player.runCommandAsync('function abilities/antidote')
	}

}
);

world.afterEvents.itemUse.subscribe((data) => {
	const player = data.source
	const level = world.scoreboard.getObjective("flash_lvl")?.getScore(player)
	const charge = world.scoreboard.getObjective("speedster_charge")?.getScore(player);
	if (data.itemStack.typeId === "flash:phase" && player.isSneaking && level == 1) {
		return Menu.ButtonMenu_1(player)
	}
	if (data.itemStack.typeId === "flash:phase" && player.isSneaking && level == 2) {
		return Menu.ButtonMenu_2(player)
	}
	if (data.itemStack.typeId === "flash:phase" && player.isSneaking && level == 3) {
		return Menu.ButtonMenu_3(player)
	}
	if (data.itemStack.typeId === "flash:phase" && player.isSneaking && level == 4) {
		return Menu.ButtonMenu_4(player)
	}
	if (data.itemStack.typeId === "flash:phase" && player.isSneaking && level == 5) {
		return Menu.ButtonMenu_5(player)
	}
	if (data.itemStack.typeId === "flash:phase" && !player.isSneaking && charge >= 3) {
		player.runCommandAsync("function abilities/phase")

	}
	if (data.itemStack.typeId === 'flash:phase' && !player.isSneaking && charge < 3) {
		player.runCommandAsync("title @s actionbar §l§cNot§r§f enough charge")
	}


}
);
world.afterEvents.itemUse.subscribe((data) => {
	const player = data.source;
	const level = world.scoreboard.getObjective("flash_lvl")?.getScore(player);
	const Score = world.scoreboard; {
		if (data.itemStack.typeId === "flash:phase_punch" && player.isSneaking && level == 1) {
			return Menu.ButtonMenu_1(player);
		}
		if (data.itemStack.typeId === "flash:phase_punch" && player.isSneaking && level == 2) {
			return Menu.ButtonMenu_2(player);
		}
		if (data.itemStack.typeId === "flash:phase_punch" && player.isSneaking && level == 3) {
			return Menu.ButtonMenu_3(player);
		}
		if (data.itemStack.typeId === "flash:phase_punch" && player.isSneaking && level == 4) {
			return Menu.ButtonMenu_4(player);
		}
		if (data.itemStack.typeId === "flash:phase_punch" && player.isSneaking && level == 5) {
			return Menu.ButtonMenu_5(player);
		}

	}

}
);

world.afterEvents.itemUse.subscribe((data) => {
	const player = data.source;
	const item = data.itemStack;
	const velocity = player.getViewDirection()
	const level = world.scoreboard.getObjective("flash_lvl")?.getScore(player);
	const charge = world.scoreboard.getObjective("speedster_charge")?.getScore(player);



	if (data.itemStack.typeId === "flash:flashbolt" && player.isSneaking && level == 2) {
		return Menu.ButtonMenu_2(player);
	}
	if (data.itemStack.typeId === "flash:flashbolt" && player.isSneaking && level == 3) {
		return Menu.ButtonMenu_3(player);
	}
	if (data.itemStack.typeId === "flash:flashbolt" && player.isSneaking && level == 4) {
		return Menu.ButtonMenu_4(player);
	}
	if (data.itemStack.typeId === "flash:flashbolt" && player.isSneaking && level == 5) {
		return Menu.ButtonMenu_5(player);
	}
})

world.afterEvents.entitySpawn.subscribe((data) => {
	const Projectile = data.entity
	const CasueSpawn = data.cause
	for (const Player of world.getPlayers()) {
		const blockedView = Player.getBlockFromViewDirection({ maxDistance: 2, includePassableBlocks: true, includeLiquidBlocks: true })
		const view = Player.getViewDirection()
		const scoreboard = world.scoreboard.getObjective("speedster_charge")
		if (Projectile.typeId === 'flash:thrown_flashbolt' && CasueSpawn == 'Spawned' && !blockedView?.block && scoreboard?.getScore(Player) >= 1) {
			Projectile.applyImpulse({ x: view.x * 2, y: view.y * 2, z: view.z * 2 })
		}
	}
})
world.afterEvents.itemUse.subscribe((data) => {
	const player = data.source;
	const item = data.itemStack;
	const velocity = player.getViewDirection()
	const level = world.scoreboard.getObjective("flash_lvl")?.getScore(player);
	const charge = world.scoreboard.getObjective("speedster_charge")?.getScore(player);
	const cooldown = world.scoreboard.getObjective("tornado_cooldown")?.getScore(player);



	if (data.itemStack.typeId === "flash:tornado" && player.isSneaking && level == 2) {
		return Menu.ButtonMenu_2(player);
	}
	if (data.itemStack.typeId === "flash:tornado" && player.isSneaking && level == 3) {
		return Menu.ButtonMenu_3(player);
	}
	if (data.itemStack.typeId === "flash:tornado" && player.isSneaking && level == 4) {
		return Menu.ButtonMenu_4(player);
	}
	if (data.itemStack.typeId === "flash:tornado" && player.isSneaking && level == 5) {
		return Menu.ButtonMenu_5(player);
	}
}
);
world.afterEvents.entitySpawn.subscribe((data) => {
	const Tornado = data.entity
	const CasueSpawn = data.cause
	for (const Player of world.getPlayers()) {
		const blockedView = Player.getBlockFromViewDirection({ maxDistance: 2, includePassableBlocks: true, includeLiquidBlocks: true })
		const view = Player.getViewDirection()
		const scoreboard = world.scoreboard.getObjective("speedster_charge")
		if (Tornado.typeId === 'flash:tornado' && CasueSpawn == 'Spawned' && !blockedView?.block && scoreboard?.getScore(Player) >= 1) {
			Tornado.applyImpulse({ x: view.x * 2, y: view.y * 2, z: view.z * 2 })
		}
	}
})









