import { system, world } from '@minecraft/server'
import { Menu } from "./flash_ui.js"

world.beforeEvents.playerInteractWithBlock.subscribe((data) => {
	const player = data.player
	const block = data.block
	if (block.typeId === "flash:speedster_station") {
		system.run(() => {
			Menu.RingConversion(player)
		});


	}

})
world.beforeEvents.worldInitialize.subscribe(({ blockComponentRegistry }) => {
	blockComponentRegistry.registerCustomComponent("flash:interact", {
		onInteract: (data => {
			const player = data.player
			const block = data.block
			if (block.typeId === "flash:speedster_station") {
				system.run(() => {
					Menu.RingConversion(player)
				});


			}
		}
		)
	})
});


world.beforeEvents.worldInitialize.subscribe(event => {
	event.blockComponentRegistry.registerCustomComponent("flash:lava_run", {
		onPlace(e) {
			const block = e.block
			const perm = block.permutation
			const above = block.above(1)
			const center = block.center();
			const entity_spawn_loc = { x: center.x, y: center.y - 0.5, z: center.z };
			if (perm.getState("flash:lava_run") === 0 && above.isAir) {
				block.dimension.runCommand(`execute if block ~ ~-1 ~ flash:barrier unless entity @e[family=flash_stand,r=0.5] run setblock ~ ~ ~ lava replace`)
				block.dimension.runCommand(`execute if block ~ ~-1 ~ flash:barrier unless entity @e[family=flash_stand,r=0.5] run setblock ~ ~1 ~ lava replace`)

			}

		}
	})
})

world.beforeEvents.worldInitialize.subscribe(event => {
	event.blockComponentRegistry.registerCustomComponent("flash:flash_stand", {
		onPlace(e) {
			const block = e.block
			const perm = block.permutation
			const above = block.above(1)
			const center = block.center();
			const entity_spawn_loc = { x: center.x, y: center.y - 0.5, z: center.z };
			if (perm.getState("minecraft:cardinal_direction") === 'north' && perm.getState("flash:flash_stand") === 0 && above.isAir) {
				above.setPermutation(perm.withState("flash:flash_stand", 1))
				block.dimension.runCommand(`summon flash:flash_armor_stand ${entity_spawn_loc.x} ${entity_spawn_loc.y} ${entity_spawn_loc.z} 180 ~`)
				block.dimension.runCommand(`give @p flash:stand_key`)
			}
			if (perm.getState("minecraft:cardinal_direction") === 'east' && perm.getState("flash:flash_stand") === 0 && above.isAir) {
				above.setPermutation(perm.withState("flash:flash_stand", 1))
				block.dimension.runCommand(`summon flash:flash_armor_stand ${entity_spawn_loc.x} ${entity_spawn_loc.y} ${entity_spawn_loc.z} -90 ~`)
				block.dimension.runCommand(`give @p flash:stand_key`)
			}
			if (perm.getState("minecraft:cardinal_direction") === 'south' && perm.getState("flash:flash_stand") === 0 && above.isAir) {
				above.setPermutation(perm.withState("flash:flash_stand", 1))
				block.dimension.runCommand(`summon flash:flash_armor_stand ${entity_spawn_loc.x} ${entity_spawn_loc.y} ${entity_spawn_loc.z} 0 ~`)
				block.dimension.runCommand(`give @p flash:stand_key`)
			}
			if (perm.getState("minecraft:cardinal_direction") === 'west' && perm.getState("flash:flash_stand") === 0 && above.isAir) {
				above.setPermutation(perm.withState("flash:flash_stand", 1))
				block.dimension.runCommand(`summon flash:flash_armor_stand ${entity_spawn_loc.x} ${entity_spawn_loc.y} ${entity_spawn_loc.z} 90 ~`)
				block.dimension.runCommand(`give @p flash:stand_key`)
			}
		}
	})
})

world.beforeEvents.worldInitialize.subscribe(event => {
	event.blockComponentRegistry.registerCustomComponent("flash:wr_stand", {
		onPlace(e) {
			const block = e.block
			const perm = block.permutation
			const above = block.above(1)
			const center = block.center();
			const entity_spawn_loc = { x: center.x, y: center.y - 0.5, z: center.z };
			if (perm.getState("minecraft:cardinal_direction") === 'north' && perm.getState("flash:wr_stand") === 0 && above.isAir) {
				above.setPermutation(perm.withState("flash:wr_stand", 1))
				block.dimension.runCommand(`give @p flash:stand_key`)
				block.dimension.runCommand(`summon flash:wr_armor_stand ${entity_spawn_loc.x} ${entity_spawn_loc.y} ${entity_spawn_loc.z} 180 ~`)
			}
			if (perm.getState("minecraft:cardinal_direction") === 'east' && perm.getState("flash:wr_stand") === 0 && above.isAir) {
				above.setPermutation(perm.withState("flash:wr_stand", 1))
				block.dimension.runCommand(`give @p flash:stand_key`)
				block.dimension.runCommand(`summon flash:wr_armor_stand ${entity_spawn_loc.x} ${entity_spawn_loc.y} ${entity_spawn_loc.z} -90 ~`)
			}
			if (perm.getState("minecraft:cardinal_direction") === 'south' && perm.getState("flash:wr_stand") === 0 && above.isAir) {
				above.setPermutation(perm.withState("flash:wr_stand", 1))
				block.dimension.runCommand(`give @p flash:stand_key`)
				block.dimension.runCommand(`summon flash:wr_armor_stand ${entity_spawn_loc.x} ${entity_spawn_loc.y} ${entity_spawn_loc.z} 0 ~`)
			}
			if (perm.getState("minecraft:cardinal_direction") === 'west' && perm.getState("flash:wr_stand") === 0 && above.isAir) {
				above.setPermutation(perm.withState("flash:wr_stand", 1))
				block.dimension.runCommand(`give @p flash:stand_key`)
				block.dimension.runCommand(`summon flash:wr_armor_stand ${entity_spawn_loc.x} ${entity_spawn_loc.y} ${entity_spawn_loc.z} 90 ~`)
			}
		}
	})
})

world.beforeEvents.worldInitialize.subscribe(event => {
	event.blockComponentRegistry.registerCustomComponent("flash:jg_stand", {
		onPlace(e) {
			const block = e.block
			const perm = block.permutation
			const above = block.above(1)
			const center = block.center();
			const entity_spawn_loc = { x: center.x, y: center.y - 0.5, z: center.z };
			if (perm.getState("minecraft:cardinal_direction") === 'north' && perm.getState("flash:jg_stand") === 0 && above.isAir) {
				above.setPermutation(perm.withState("flash:jg_stand", 1))
				block.dimension.runCommand(`give @p flash:stand_key`)
				block.dimension.runCommand(`summon flash:jg_armor_stand ${entity_spawn_loc.x} ${entity_spawn_loc.y} ${entity_spawn_loc.z} 180 ~`)
			}
			if (perm.getState("minecraft:cardinal_direction") === 'east' && perm.getState("flash:jg_stand") === 0 && above.isAir) {
				above.setPermutation(perm.withState("flash:jg_stand", 1))
				block.dimension.runCommand(`give @p flash:stand_key`)
				block.dimension.runCommand(`summon flash:jg_armor_stand ${entity_spawn_loc.x} ${entity_spawn_loc.y} ${entity_spawn_loc.z} -90 ~`)
			}
			if (perm.getState("minecraft:cardinal_direction") === 'south' && perm.getState("flash:jg_stand") === 0 && above.isAir) {
				above.setPermutation(perm.withState("flash:jg_stand", 1))
				block.dimension.runCommand(`give @p flash:stand_key`)
				block.dimension.runCommand(`summon flash:jg_armor_stand ${entity_spawn_loc.x} ${entity_spawn_loc.y} ${entity_spawn_loc.z} 0 ~`)
			}
			if (perm.getState("minecraft:cardinal_direction") === 'west' && perm.getState("flash:jg_stand") === 0 && above.isAir) {
				above.setPermutation(perm.withState("flash:jg_stand", 1))
				block.dimension.runCommand(`give @p flash:stand_key`)
				block.dimension.runCommand(`summon flash:jg_armor_stand ${entity_spawn_loc.x} ${entity_spawn_loc.y} ${entity_spawn_loc.z} 90 ~`)
			}
		}
	})
})

world.beforeEvents.worldInitialize.subscribe(event => {
	event.blockComponentRegistry.registerCustomComponent("flash:impulse_stand", {
		onPlace(e) {
			const block = e.block
			const perm = block.permutation
			const above = block.above(1)
			const center = block.center();
			const entity_spawn_loc = { x: center.x, y: center.y - 0.5, z: center.z };
			if (perm.getState("minecraft:cardinal_direction") === 'north' && perm.getState("flash:impulse_stand") === 0 && above.isAir) {
				above.setPermutation(perm.withState("flash:impulse_stand", 1))
				block.dimension.runCommand(`give @p flash:stand_key`)
				block.dimension.runCommand(`summon flash:impulse_armor_stand ${entity_spawn_loc.x} ${entity_spawn_loc.y} ${entity_spawn_loc.z} 180 ~`)
			}
			if (perm.getState("minecraft:cardinal_direction") === 'east' && perm.getState("flash:impulse_stand") === 0 && above.isAir) {
				above.setPermutation(perm.withState("flash:impulse_stand", 1))
				block.dimension.runCommand(`give @p flash:stand_key`)
				block.dimension.runCommand(`summon flash:impulse_armor_stand ${entity_spawn_loc.x} ${entity_spawn_loc.y} ${entity_spawn_loc.z} -90 ~`)
			}
			if (perm.getState("minecraft:cardinal_direction") === 'south' && perm.getState("flash:impulse_stand") === 0 && above.isAir) {
				above.setPermutation(perm.withState("flash:impulse_stand", 1))
				block.dimension.runCommand(`give @p flash:stand_key`)
				block.dimension.runCommand(`summon flash:impulse_armor_stand ${entity_spawn_loc.x} ${entity_spawn_loc.y} ${entity_spawn_loc.z} 0 ~`)
			}
			if (perm.getState("minecraft:cardinal_direction") === 'west' && perm.getState("flash:impulse_stand") === 0 && above.isAir) {
				above.setPermutation(perm.withState("flash:impulse_stand", 1))
				block.dimension.runCommand(`give @p flash:stand_key`)
				block.dimension.runCommand(`summon flash:impulse_armor_stand ${entity_spawn_loc.x} ${entity_spawn_loc.y} ${entity_spawn_loc.z} 90 ~`)
			}
		}
	})
})
world.beforeEvents.worldInitialize.subscribe(event => {
	event.blockComponentRegistry.registerCustomComponent("flash:savitar_stand", {
		onPlace(e) {
			const block = e.block
			const perm = block.permutation
			const above = block.above(1)
			const center = block.center();
			const entity_spawn_loc = { x: center.x, y: center.y - 0.5, z: center.z };
			if (perm.getState("minecraft:cardinal_direction") === 'north' && perm.getState("flash:savitar_stand") === 0 && above.isAir) {
				above.setPermutation(perm.withState("flash:savitar_stand", 1))
				block.dimension.runCommand(`give @p flash:stand_key`)
				block.dimension.runCommand(`summon flash:savitar_armor_stand ${entity_spawn_loc.x} ${entity_spawn_loc.y} ${entity_spawn_loc.z} 180 ~`)
			}
			if (perm.getState("minecraft:cardinal_direction") === 'east' && perm.getState("flash:savitar_stand") === 0 && above.isAir) {
				above.setPermutation(perm.withState("flash:savitar_stand", 1))
				block.dimension.runCommand(`give @p flash:stand_key`)
				block.dimension.runCommand(`summon flash:savitar_armor_stand ${entity_spawn_loc.x} ${entity_spawn_loc.y} ${entity_spawn_loc.z} -90 ~`)
			}
			if (perm.getState("minecraft:cardinal_direction") === 'south' && perm.getState("flash:savitar_stand") === 0 && above.isAir) {
				above.setPermutation(perm.withState("flash:savitar_stand", 1))
				block.dimension.runCommand(`give @p flash:stand_key`)
				block.dimension.runCommand(`summon flash:savitar_armor_stand ${entity_spawn_loc.x} ${entity_spawn_loc.y} ${entity_spawn_loc.z} 0 ~`)
			}
			if (perm.getState("minecraft:cardinal_direction") === 'west' && perm.getState("flash:savitar_stand") === 0 && above.isAir) {
				above.setPermutation(perm.withState("flash:savitar_stand", 1))
				block.dimension.runCommand(`give @p flash:stand_key`)
				block.dimension.runCommand(`summon flash:savitar_armor_stand ${entity_spawn_loc.x} ${entity_spawn_loc.y} ${entity_spawn_loc.z} 90 ~`)
			}
		}
	})
})
world.beforeEvents.worldInitialize.subscribe(event => {
	event.blockComponentRegistry.registerCustomComponent("flash:xs_stand", {
		onPlace(e) {
			const block = e.block
			const perm = block.permutation
			const above = block.above(1)
			const center = block.center();
			const entity_spawn_loc = { x: center.x, y: center.y - 0.5, z: center.z };
			if (perm.getState("minecraft:cardinal_direction") === 'north' && perm.getState("flash:xs_stand") === 0 && above.isAir) {
				above.setPermutation(perm.withState("flash:xs_stand", 1))
				block.dimension.runCommand(`give @p flash:stand_key`)
				block.dimension.runCommand(`summon flash:xs_armor_stand ${entity_spawn_loc.x} ${entity_spawn_loc.y} ${entity_spawn_loc.z} 180 ~`)
			}
			if (perm.getState("minecraft:cardinal_direction") === 'east' && perm.getState("flash:xs_stand") === 0 && above.isAir) {
				above.setPermutation(perm.withState("flash:xs_stand", 1))
				block.dimension.runCommand(`give @p flash:stand_key`)
				block.dimension.runCommand(`summon flash:xs_armor_stand ${entity_spawn_loc.x} ${entity_spawn_loc.y} ${entity_spawn_loc.z} -90 ~`)
			}
			if (perm.getState("minecraft:cardinal_direction") === 'south' && perm.getState("flash:xs_stand") === 0 && above.isAir) {
				above.setPermutation(perm.withState("flash:xs_stand", 1))
				block.dimension.runCommand(`give @p flash:stand_key`)
				block.dimension.runCommand(`summon flash:xs_armor_stand ${entity_spawn_loc.x} ${entity_spawn_loc.y} ${entity_spawn_loc.z} 0 ~`)
			}
			if (perm.getState("minecraft:cardinal_direction") === 'west' && perm.getState("flash:xs_stand") === 0 && above.isAir) {
				above.setPermutation(perm.withState("flash:xs_stand", 1))
				block.dimension.runCommand(`give @p flash:stand_key`)
				block.dimension.runCommand(`summon flash:xs_armor_stand ${entity_spawn_loc.x} ${entity_spawn_loc.y} ${entity_spawn_loc.z} 90 ~`)
			}
		}
	})
})
world.beforeEvents.worldInitialize.subscribe(event => {
	event.blockComponentRegistry.registerCustomComponent("flash:gs_stand", {
		onPlace(e) {
			const block = e.block
			const perm = block.permutation
			const above = block.above(1)
			const center = block.center();
			const entity_spawn_loc = { x: center.x, y: center.y - 0.5, z: center.z };
			if (perm.getState("minecraft:cardinal_direction") === 'north' && perm.getState("flash:gs_stand") === 0 && above.isAir) {
				above.setPermutation(perm.withState("flash:gs_stand", 1))
				block.dimension.runCommand(`give @p flash:stand_key`)
				block.dimension.runCommand(`summon flash:gs_armor_stand ${entity_spawn_loc.x} ${entity_spawn_loc.y} ${entity_spawn_loc.z} 180 ~`)
			}
			if (perm.getState("minecraft:cardinal_direction") === 'east' && perm.getState("flash:gs_stand") === 0 && above.isAir) {
				above.setPermutation(perm.withState("flash:gs_stand", 1))
				block.dimension.runCommand(`give @p flash:stand_key`)
				block.dimension.runCommand(`summon flash:gs_armor_stand ${entity_spawn_loc.x} ${entity_spawn_loc.y} ${entity_spawn_loc.z} -90 ~`)
			}
			if (perm.getState("minecraft:cardinal_direction") === 'south' && perm.getState("flash:gs_stand") === 0 && above.isAir) {
				above.setPermutation(perm.withState("flash:gs_stand", 1))
				block.dimension.runCommand(`give @p flash:stand_key`)
				block.dimension.runCommand(`summon flash:gs_armor_stand ${entity_spawn_loc.x} ${entity_spawn_loc.y} ${entity_spawn_loc.z} 0 ~`)
			}
			if (perm.getState("minecraft:cardinal_direction") === 'west' && perm.getState("flash:gs_stand") === 0 && above.isAir) {
				above.setPermutation(perm.withState("flash:gs_stand", 1))
				block.dimension.runCommand(`give @p flash:stand_key`)
				block.dimension.runCommand(`summon flash:gs_armor_stand ${entity_spawn_loc.x} ${entity_spawn_loc.y} ${entity_spawn_loc.z} 90 ~`)
			}
		}
	})
})
world.beforeEvents.worldInitialize.subscribe(event => {
	event.blockComponentRegistry.registerCustomComponent("flash:zoom_stand", {
		onPlace(e) {
			const block = e.block
			const perm = block.permutation
			const above = block.above(1)
			const center = block.center();
			const entity_spawn_loc = { x: center.x, y: center.y - 0.5, z: center.z };
			if (perm.getState("minecraft:cardinal_direction") === 'north' && perm.getState("flash:zoom_stand") === 0 && above.isAir) {
				above.setPermutation(perm.withState("flash:zoom_stand", 1))
				block.dimension.runCommand(`give @p flash:stand_key`)
				block.dimension.runCommand(`summon flash:zoom_armor_stand ${entity_spawn_loc.x} ${entity_spawn_loc.y} ${entity_spawn_loc.z} 180 ~`)
			}
			if (perm.getState("minecraft:cardinal_direction") === 'east' && perm.getState("flash:zoom_stand") === 0 && above.isAir) {
				above.setPermutation(perm.withState("flash:zoom_stand", 1))
				block.dimension.runCommand(`give @p flash:stand_key`)
				block.dimension.runCommand(`summon flash:zoom_armor_stand ${entity_spawn_loc.x} ${entity_spawn_loc.y} ${entity_spawn_loc.z} -90 ~`)
			}
			if (perm.getState("minecraft:cardinal_direction") === 'south' && perm.getState("flash:zoom_stand") === 0 && above.isAir) {
				above.setPermutation(perm.withState("flash:zoom_stand", 1))
				block.dimension.runCommand(`give @p flash:stand_key`)
				block.dimension.runCommand(`summon flash:zoom_armor_stand ${entity_spawn_loc.x} ${entity_spawn_loc.y} ${entity_spawn_loc.z} 0 ~`)
			}
			if (perm.getState("minecraft:cardinal_direction") === 'west' && perm.getState("flash:zoom_stand") === 0 && above.isAir) {
				above.setPermutation(perm.withState("flash:zoom_stand", 1))
				block.dimension.runCommand(`give @p flash:stand_key`)
				block.dimension.runCommand(`summon flash:zoom_armor_stand ${entity_spawn_loc.x} ${entity_spawn_loc.y} ${entity_spawn_loc.z} 90 ~`)
			}
		}
	})
})

world.beforeEvents.worldInitialize.subscribe(event => {
	event.blockComponentRegistry.registerCustomComponent("flash:rf_stand", {
		onPlace(e) {
			const block = e.block
			const perm = block.permutation
			const above = block.above(1)
			const center = block.center();
			const entity_spawn_loc = { x: center.x, y: center.y - 0.5, z: center.z };
			if (perm.getState("minecraft:cardinal_direction") === 'north' && perm.getState("flash:rf_stand") === 0 && above.isAir) {
				above.setPermutation(perm.withState("flash:rf_stand", 1))
				block.dimension.runCommand(`give @p flash:stand_key`)
				block.dimension.runCommand(`summon flash:rf_armor_stand ${entity_spawn_loc.x} ${entity_spawn_loc.y} ${entity_spawn_loc.z} 180 ~`)
			}
			if (perm.getState("minecraft:cardinal_direction") === 'east' && perm.getState("flash:rf_stand") === 0 && above.isAir) {
				above.setPermutation(perm.withState("flash:rf_stand", 1))
				block.dimension.runCommand(`give @p flash:stand_key`)
				block.dimension.runCommand(`summon flash:rf_armor_stand ${entity_spawn_loc.x} ${entity_spawn_loc.y} ${entity_spawn_loc.z} -90 ~`)
			}
			if (perm.getState("minecraft:cardinal_direction") === 'south' && perm.getState("flash:rf_stand") === 0 && above.isAir) {
				above.setPermutation(perm.withState("flash:rf_stand", 1))
				block.dimension.runCommand(`give @p flash:stand_key`)
				block.dimension.runCommand(`summon flash:rf_armor_stand ${entity_spawn_loc.x} ${entity_spawn_loc.y} ${entity_spawn_loc.z} 0 ~`)
			}
			if (perm.getState("minecraft:cardinal_direction") === 'west' && perm.getState("flash:rf_stand") === 0 && above.isAir) {
				above.setPermutation(perm.withState("flash:rf_stand", 1))
				block.dimension.runCommand(`give @p flash:stand_key`)
				block.dimension.runCommand(`summon flash:rf_armor_stand ${entity_spawn_loc.x} ${entity_spawn_loc.y} ${entity_spawn_loc.z} 90 ~`)
			}
		}
	})
})
